%global momorel 5

%define cman_major 2
%define cman_minor 0.60

%define buildxen 0

%ifarch i686 x86_64 ia64
%define buildxen 1
%endif

Name: cman
Version: %{cman_major}.%{cman_minor}
Release: %{momorel}m%{?dist}
License: GPL
Group: System Environment/Base
Summary: cman - The Cluster Manager
#BuildRequires: kernel >= 2.6.16
BuildRequires: glibc-kernheaders
BuildRequires: libxml2-devel
BuildRequires: openais-devel openais
BuildRequires: perl

%if %{buildxen}
BuildRequires: nss-devel nspr-devel libvirt-devel xen-libs
Requires: nss nspr libvirt xen xen-libs
%endif

Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires: openais, perl-Net-Telnet
URL: http://sources.redhat.com/cluster/
Source0: %{name}-%{version}.tar.gz
Patch0: cman-2.0.5-libraryfix.patch
Patch1: cman-makefix.patch
Patch2: cman-plocktemp.patch
Patch3: cman-2.0.14-defaultrun.patch

Patch100: cman-2.0.60-glibc28.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
cman - The Cluster Manager

%package devel
Group: Development/Libraries
Summary: cman cluster manager development package
Requires: cman = %{version}-%{release}

%description devel
cman - The Cluster Manager

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1 -b .libraryfix
%patch1 -p1 -b .makefix
%patch2 -p1 -b .plock
%patch3 -p1 -b .defaultrun


%patch100 -p1 -b .glibc28

%build
TOPDIR=`pwd`

cd ccs ; ./configure --libdir=%{_libdir}; cd ..
cd dlm ; ./configure --kernel_src=/usr/ --libdir=%{_libdir}; cd ..
cd cman; ./configure --ccsincdir=${TOPDIR}/ccs/lib --ccslibdir=${TOPDIR}/ccs/lib --libdir=%{_libdir}  ; cd ..
cd group; ./configure --kernel_src=/usr/ --libdir=%{_libdir} --cmanlibdir=${TOPDIR}/cman/lib; cd ..

%if %{buildxen}
cd fence; ./configure --enable_xen --ccslibdir=${TOPDIR}/ccs/lib --ccsincdir=${TOPDIR}/ccs/lib --cmanincdir=${TOPDIR}/cman/lib --libdir=%{_libdir}; cd ..
%else
cd fence; ./configure --ccslibdir=${TOPDIR}/ccs/lib --ccsincdir=${TOPDIR}/ccs/lib --cmanincdir=${TOPDIR}/cman/lib --libdir=%{_libdir}; cd ..
%endif

ls -l /usr/lib/
ls -l /

for dir in ccs cman dlm fence group; do
  cd $dir
  sed -i '/RELEASE_MAJOR/s/= .*/= %{cman_major}/' make/defines.mk
  sed -i '/RELEASE_MINOR/s/= .*/= %{cman_minor}/' make/defines.mk
  sed -i '/RELEASE /s/= .*/= %version/' make/defines.mk
  cd ..
done

for dir in 'cman/lib' ccs cman dlm group fence; do
  cd $dir
  make
  cd $TOPDIR
done

# no auto start
perl -p -i -e 's@^# chkconfig: (\d+) (\d+) (\d+)$@# chkconfig: - $2 $3@' fence/agents/scsi/scsi_reserve

%install
TOPDIR=`pwd`
rm -rf --preserve-root %{buildroot}
for dir in ccs cman dlm fence group; do
  cd $dir
  make install DESTDIR=%{buildroot}
  cd $TOPDIR
done

mkdir -p %{buildroot}/var/run/cluster

%clean
rm -rf --preserve-root %{buildroot}

%post
/sbin/chkconfig --add cman

%preun
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del cman
fi

%files
%defattr(-,root,root,-)
/sbin/*
/usr/sbin/*
%{_sysconfdir}/init.d/*
%{_libexecdir}/lcrso/service_cman.lcrso
%{_libdir}/*.so*
%{_mandir}/*/*
%dir /var/run/cluster

%files devel
%defattr(-,root,root,-)
%{_includedir}/*
%{_libdir}/*.a

%changelog
* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.0.60-5m)
- rebuild against gcc43

* Sun Feb 24 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (2.0.60-4m)
- fix glibc-2.8

* Wed Jun 20 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.0.60-3m)
- stop auto start

* Sun Feb 25 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.0.60-2m)
- revise %%files to avoid conflicting
- %%{_libexecdir}/lcrso is already provided by openais

* Tue Feb 20 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (2.0.60-1m)
- Initial commit. import from FC-devel
